<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\LokasiitemModel;
use App\Http\Models\KapallokasiitemModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class LokasiitemService extends BaseService
{
	/**
     LokasiitemService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new LokasiitemModel();
		$this->kapalSubinv = new KapallokasiitemModel();
	}

	/**
	 *  index function that get all sub inventory based on kapal id session from database by default
	 *  @return array|static[]
	 */
	public function index($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		if ($auth->aplikasi != "HO") {
			return $this->kapalSubinv->joinRelationLokasiId()->getQuery()
				->select(["lokasiId.*"])
				->where("kapalLokasiItem.kapalId", "=", $auth->kapalId)
				->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi)
				->get();
		} else {
			return $this->model->getQuery()->get();
		}
	}

	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		/* $this->model->joinRelationKapalId()->getQuery()->select(["lokasiitem.id as id",
			"lokasiitem.namaLokasi as namaLokasi",
			"lokasiitem.alamatLokasi as alamatLokasi",
			"lokasiitem.lokasi as lokasi",
			"kapalId.id as kapalId",
			"kapalId.namaKapal"]);

		if($auth->aplikasi != "HO") { 
			$this->model->getQuery()->where("kapalId.id", "=", $auth->kapalId);
		} */

		if ($auth->aplikasi != "HO") {
			$this->kapalSubinv->joinRelationKapalId()->joinRelationLokasiId()->getQuery()
				->select(["lokasiId.*", "kapalId.id as kapalId", "kapalId.namaKapal", "kapalLokasiItem.*"])
				->where("kapalLokasiItem.kapalId", "=", $auth->kapalId)
				->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi);
		} else {
			$this->kapalSubinv->joinRelationKapalId()->joinRelationLokasiId()->getQuery()
				->select(["lokasiId.*", "kapalId.id as kapalId", "kapalId.namaKapal", "kapalLokasiItem.*"])
				// ->where("kapalLokasiItem.kapalId", "=", $auth->kapalId)
				->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi);
		}
		$this->kapalSubinv->paging()->filter()->sorting();
		$model = $this->kapalSubinv->paging()->getPaging();

		$newRow = [];
		$namaKapal = "";
		foreach ($model["rows"] as $row) {
			if (isset($newRow[$row->id])) {
				if (!in_array($row->namaKapal, $newRow[$row->id]->namaKapal)) {
					$newRow[$row->id]->namaKapal[] = $row->namaKapal;
				}
			} else {
				$newRow[$row->id] = (object) [
					"id" => $row->id,
					"kapalId" => $row->kapalId,
					"namaLokasi" => $row->namaLokasi,
					"alamatLokasi" => $row->alamatLokasi,
					"lokasi" => $row->lokasi,
					"namaKapal" => [$row->namaKapal]
				];
			}
		}
		$model["rows"] = $newRow;
		return $model;
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return LokasiitemModel
	 */
	public function show($id)
	{
		$model = $this->kapalSubinv->joinRelationKapalId()->joinRelationLokasiId()->getQuery()
			->select(["lokasiId.*", "kapalId.namaKapal", "kapalId.kodeKapal", "kapalLokasiItem.*"])
			->where("kapalLokasiItem.id", "=", $id)->get();

		if ($model) {
			$subInventory = $model[0];
			$kapals = [];
			foreach ($model as $row) {
				$kapals[$row->kodeKapal] = $row->namaKapal;
			}
			$subInventory->namaKapal = $kapals;
			return $subInventory;
		} else {
			return null;
		}
	}

	public function showByLokasiID($id)
	{
		$model = $this->kapalSubinv->joinRelationKapalId()->joinRelationLokasiId()->getQuery()
			->select(["lokasiId.*", "kapalId.namaKapal", "kapalId.kodeKapal", "kapalLokasiItem.*"])
			->where("kapalLokasiItem.lokasiId", "=", $id)->get();

		if ($model) {
			$subInventory = $model[0];
			$kapals = [];
			foreach ($model as $row) {
				$kapals[$row->kodeKapal] = $row->namaKapal;
			}
			$subInventory->namaKapal = $kapals;
			return $subInventory;
		} else {
			return null;
		}
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return LokasiitemModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$this->model->fill($input);
		$maxID = $this->model->getQuery()->orderBy("id", "desc")->first();
		if (is_object($maxID)) {
			$ID = $maxID->id + 1;
		} else {
			$ID = 1;
		}
		$this->model->id = $ID;

		if (!$this->model->save()) {
			throw new \Exception();
		}
		return $ID;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return LokasiitemModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$lokasiitem = LokasiitemModel::find($id);
		$lokasiitem->fill($input);
		if (!$lokasiitem->update()) {
			throw new \Exception();
		}
		return $lokasiitem;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function getList($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		if ($auth->aplikasi != "HO") {
			return $this->model->getQuery()->where("lokasiitem.kapalId", "=", $auth->kapalId)->get();
		} else {
			$input = $request->all();
			if (isset($input["kapalID"]) && $input["kapalID"] > 0) {
				return $this->model->getQuery()->where("lokasiitem.kapalId", "=", $input["kapalID"])->get();
			} else {
				return $this->model->getQuery()->get();
			}
		}
	}

	public function getListNotIn($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		$input = $request->all();

		if ($auth->aplikasi != "HO") {
			return $this->kapalSubinv->joinRelationLokasiId()->getQuery()
				->select(["lokasiId.*"])
				->whereNotIn("kapalLokasiItem.lokasiId", explode(",", $input["lokasiId"]))
				->where("kapalLokasiItem.kapalId", "=", $auth->kapalId)
				// ->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi)
				->get();
		} else {
			if (isset($input["kapalID"]) && $input["kapalID"] > 0) {
				return $this->model->joinRelationKapalLokasiItem()->getQuery()->select(["lokasiitem.*"])
					->whereNotIn("lokasiitem.id", explode(",", $input["lokasiId"]))
					->where("kapalLokasiItem.kapalId", "=", $input["kapalID"])->get();
			} else {
				return $this->model->getQuery()->whereNotIn("lokasiitem.id", explode(",", $input["lokasiId"]))->get();
			}
		}
	}

	// get sub inventory based on kapal id from input ( if you wanna get the list based on kapal id session, please use $this->index() )
	public function getKapalSubInv($request)
	{
		$input = $request->all();
		$auth = json_decode($request->session()->get('auth'));
		return (new KapallokasiitemModel())->joinRelationLokasiId()->getQuery()
			->select(["lokasiId.id", "lokasiId.namaLokasi"])
			->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi)
			->where("kapalLokasiItem.kapalId", "=", $input["toKapalId"])->get();
	}

	public function getLokasiByName($subInvCode)
	{
		$model = $this->model->getQuery()->where("namaLokasi", "=", $subInvCode)->first();
		return $model;
	}
	public function getBBM($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		if ($auth->aplikasi != "HO") {
			return $this->kapalSubinv->joinRelationLokasiId()->getQuery()
				->select(["lokasiId.*"])
				->where("lokasiId.namaLokasi", "ILIKE", '%bbm%')
				->where("kapalLokasiItem.kapalId", "=", $auth->kapalId)
				->whereIn("kapalLokasiItem.lokasiId", $auth->arrLokasi)
				->get();
		} else {
			return $this->model->getQuery()->get();
		}
	}
}
